package at.ac.uibk.gitsearch.repository.jpa;

import at.ac.uibk.gitsearch.domain.ReviewHistoryEntry;
import at.ac.uibk.gitsearch.domain.User;
import java.util.List;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

/**
 * Spring Data JPA repository for the ReviewHistoryEntry entity.
 */
@Repository
public interface ReviewHistoryEntryJPARepository
    extends JpaRepository<ReviewHistoryEntry, Long>, JpaSpecificationExecutor<ReviewHistoryEntry> {
    @Query(
        "SELECT entry FROM ReviewHistoryEntry entry LEFT JOIN ReviewRating rr ON rr = entry.reviewRating WHERE entry.review.id = :reviewId AND (:reviewRatingId is null OR rr.id = :reviewRatingId) " +
        "AND (entry.review.requestedBy = :#{#user.id} OR rr.user = :user)"
    )
    List<ReviewHistoryEntry> findByReviewReviewRatingAndUser(
        @Param("reviewId") Long reviewId,
        @Param("reviewRatingId") Long reviewRatingId,
        @Param("user") User user
    );
}
