import { HttpClientModule } from '@angular/common/http';
import { HttpClientTestingModule, HttpTestingController } from '@angular/common/http/testing';
import { TestBed } from '@angular/core/testing';
import { RouterTestingModule } from '@angular/router/testing';
import { TranslateModule } from '@ngx-translate/core';
import { ApplicationConfigService } from 'app/core/config/application-config.service';
import { LocalStorageService, SessionStorageService } from 'ngx-webstorage';
import { IndexManagementService } from './index-management.service';

describe('IndexManagementService', () => {
  let service: IndexManagementService;
  let httpMock: HttpTestingController;
  let applicationConfigService: ApplicationConfigService;

  beforeEach(async () => {
    await TestBed.configureTestingModule({
      imports: [HttpClientTestingModule, HttpClientModule, TranslateModule.forRoot(), RouterTestingModule],
      declarations: [],
      providers: [ApplicationConfigService, LocalStorageService, SessionStorageService],
    }).compileComponents();

    applicationConfigService = TestBed.inject(ApplicationConfigService);
    service = TestBed.inject(IndexManagementService);
    httpMock = TestBed.inject(HttpTestingController);
  });

  it('should inject', () => {
    expect(service).toBeTruthy();
    expect(httpMock).toBeTruthy();

    // just to avoid the warning
    let isInvoked = 0;
    service.getIndices().subscribe(() => {
      // eslint-disable-next-line @typescript-eslint/no-unused-vars
      isInvoked++;
    });
    httpMock.expectNone({
      method: 'POST',
      url: applicationConfigService.getEndpointFor('api/esManagement/indices'),
    });
  });

  /*
  it('test Caching', inject(
    [],
    fakeAsync(() => {
    let isInvoked = 0;
    service.getIndices().subscribe(() => {
      isInvoked++;
    });
    tick();
    expect(isInvoked).toEqual(1); // it is invoked with undefined
    const testRequest = httpMock.expectOne({
      method: 'POST',
      url: applicationConfigService.getEndpointFor('api/esManagement/indices'),
    });
    testRequest.flush({
      reviewInProgress: 0,
      reviewImproved: 0,
      reviewCompleted: 0,
      unknownStats: 0,
      reviewsRequestedByReviewer: 2,
      reviewInProgressByReviewer: 0,
      reviewImprovementRequestedByReviewer: 2,
      reviewCompletedByReviewer: 0,
      unkownStatsByReviewer: 0,
      badgesRewarded: 1,
    });
    expect(isInvoked).toEqual(2);

    service.getAliasses().subscribe(() => {
      isInvoked++;
    });
    expect(isInvoked).toEqual(3); // result is returned immediately from cache
    httpMock.expectNone({});
  })
  ))
  */
});
